#define EMUSTATUS_ERROR		-1
#define EMUSTATUS_CREATE	0
#define EMUSTATUS_LOAD		1
#define EMUSTATUS_OPEN		2
#define EMUSTATUS_READY		3
#define EMUSTATUS_PLAYING	4

#define VOICE_FM	0
#define VOICE_PCM	1

typedef struct
{
	BYTE bm;
	BYTE bl;
	BYTE pc;

	// member for drum: normal must set 0 to these
	BYTE mapnote;
	BYTE drumnote;

	BYTE lfo;
	BYTE pan;
	BOOL pe;
	BYTE alg;	// only FM

	// extended member
	UINT type;
	BYTE version;

	// member for PCM
	DWORD fs;
	BOOL rm;
	BYTE wavno;
	DWORD lp;
	DWORD ep;
}CHPARAM;

typedef struct
{
				// max val
	BYTE multi;	//15	; only FM
	BYTE dt;	//7		; only FM
	BYTE ar;	//15
	BYTE dr;	//15
	BYTE sr;	//15
	BYTE rr;	//15
	BYTE sl;	//15
	BYTE tl;	//63
	BYTE ksl;	//3		; only FM
	BYTE dam;	//3
	BYTE dvb;	//3
	BYTE fb;	//7		; only FM
	BYTE ws;	//31	; only FM

	BOOL xof;
	BOOL sus;
	BOOL ksr;	//		; only FM
	BOOL eam;
	BOOL evb;
}OPPARAM;

void SetEmuMPWnd(HWND hWnd);

void setExclusiveFMCh(BYTE* data, CHPARAM* chp);
void setExclusiveFMOp(BYTE* data, OPPARAM* opp);
UINT setExclusiveFMAll(BYTE* data, CHPARAM* chp, OPPARAM* opps);
UINT setExclusivePCMAll(BYTE* data, CHPARAM* chp, OPPARAM* opp);

BOOL Emu526829(void);
BOOL Emu5282(void);
BOOL EmuInitialize(void);
void EmuUninitialize(void);
BOOL EmuSMAFPlay(SMAF* smaf, UINT startfrom);
void EmuSMAFStop(void);
int EmuStatus(void);
int EmuInfo(void);
int EmuGetCurrentPos(void);
BOOL EmuSeek(UINT pos);
int EmuSetMidiMsg(BYTE* data, DWORD size);
BOOL EmuSetVolume(int vol);
BOOL EmuSetTempo(int tempo);
BOOL EmuSetKeypitch(int key);
int EmuGetVolume(void);
int EmuGetTempo(void);
int EmuGetKeypitch(void);

BOOL EmuMIDISetVolume(void);
BOOL DoEvent(EVENT* ev, BOOL issound);
BOOL EmuMIDIPlay(SMAF* smaf, UINT startfrom);
BOOL EmuMIDIStop(void);
BOOL EmuMIDIProc(void);
void EmuMIDISetSoloCh(int ch);

typedef struct _tag_NOTEOFF
{
	int ch;
	int sound;
	UINT time;
	struct _tag_NOTEOFF* next;
}NOTEOFF;
